/*
 * type.c
 */



/* try to be compiler independent	*/

#define int16   short   /* same as int in LSC */
#define card16  unsigned short
#define int32   long    /* same as int in MPWC */
#define card32  unsigned long

/* maybe we'll check for the functionality */
#ifndef _WaitNextEvent
#define _WaitNextEvent 0xA860
#endif

/* define trap number for old MPW or non-MPW C */
#ifndef _Unimplemented
#define _Unimplemented 0xA89F
#endif


#define NULL 0L

/*
 * Resource ID constants.
 */

#define appleMenuID	128   /* This identifies the apple menu*/
#define fileMenuID	129
#define editMenuID	130
#define fontMenuID	131
#define drawMenuID	132

#define firstMenuID	appleMenuID
#define menuCount	5


#define appleMenu 		0  	/* explicit MyMenus[] array index */
#define aboutMeCommand  1  /* menu item index */

#define fileMenu 		1  /* explicit MyMenus[] array index */
#define quitCommand		1

#define editMenu 		2  /* explicit MyMenus[] array index */

#define fontMenu 		3  /* explicit MyMenus[] array index */

#define drawMenu		4

#define uprightCommand		1
#define reflectCommand		2
#define rotateCommand		3
#define skewCommand			4
#define linearCommand		5

/*
 * Support for the About Dialog
 */
#define	aboutMeDLOG	128
#define	okButton	1

/* alert dialogs to tell user what is happening */
#define noWaitNextEvent 128
#define noATM 130

#define DEGTORAD (2*3.14159/360)

#include "ATMInterface.h"
#include <color.h>
#include <math.h>


int16 main(void);
int16 initMacintosh(void);
int16 initATM(void);
void SetupMenus(void);
int16 InitFontMenu(void);
int16 handleEvent(void);
int16 drawType(void);
Boolean TrapImplemented(int16);
Boolean TrapAvailable(int16, int16);

static void DoKeyDown(EventRecord *);
static void doCommand(int16,int16);
static void showAboutMeDialog(void) ;


/* globals  */
MenuHandle *MyMenus;
static card32 seed;
int16 fontitem, numfonts,drawitem= uprightCommand;
char fontname[256];
WindowPtr myWindow;
card32 sleeptime = 5;
unsigned char mychar;
Boolean hasCQD;

int16 main()
	{
	CursHandle watchHdl;
	seed = 0L;
	if (!initMacintosh())
		return 0;

/* check if ATM is available, quit if not	*/

	if (!initATM())
		{
			Alert(noATM,NULL);
			return 0;
		}

/*   we are going to do some work so let's use the watch */

  	watchHdl = GetCursor(watchCursor);
	SetCursor(*watchHdl);

/* 	setup the font menu so that only available fonts appear undimmed  */
/*	InitFontMenu returns 0 if there are no outlines available to ATM	*/	
	if(!InitFontMenu())
		return 0;
		
	InitCursor();
	InvalRect(&myWindow->portRect);
	for (; handleEvent();)
		{
		}	/* for */
	return 1;
	}

static int16 initMacintosh()
	{
   	SysEnvRec theWorld;
   	
	InitGraf(&thePort);
	InitFonts();
	InitWindows();
	FlushEvents(everyEvent, 0);
  	InitDialogs(NULL);
	TEInit();
	InitCursor();
	SetupMenus();
	SetFractEnable(true);
    SysEnvirons(1, &theWorld);
	hasCQD = theWorld.hasColorQD;
	if(!TrapImplemented(_WaitNextEvent))
		{
			Alert(noWaitNextEvent,NULL);
			return 0;
		}
	return 1;
	}

static int16 handleEvent()
	{
		EventRecord e;
		WindowRecord *w;
		long s;
		Rect b;
		
		if (WaitNextEvent(everyEvent, &e, sleeptime, 0L))
			{
			switch (e.what)
				{
				case mouseDown:
					switch (FindWindow(e.where, &w))
						{
						case inContent:
							if ((WindowRecord *) FrontWindow() != w)
								SelectWindow(w);
							else if (((WindowRecord *) w)->windowKind < 0)
								SystemClick(&e, w);
							break;
						case inDrag:
							b = (**GrayRgn).rgnBBox;
							DragWindow(w, e.where, &b);
							break;
						case inGoAway:
							if (TrackGoAway(w, e.where))
								{
								CloseWindow(w);
								if (!FrontWindow())
									return 0;
								}
							break;
						case inGrow:
							SetRect(&b, 30, 30, 0x7fff, 0x7fff);
							s = GrowWindow(w, e.where, &b);
							if (s)
								{
								SizeWindow(w, LoWord(s), HiWord(s), 1);
								SetPort(w);
								InvalRect(&myWindow->portRect);
								}
							break;
						case inZoomIn:
							if (TrackBox(w, e.where, inZoomIn))
								{
								ZoomWindow(w, inZoomIn, 0);
								SetPort(w);
								InvalRect(&myWindow->portRect);
								}
							break;
						case inZoomOut:
							if (TrackBox(w, e.where, inZoomOut))
								{
								ZoomWindow(w, inZoomOut, 0);
								SetPort(w);
								InvalRect(&myWindow->portRect);
								}
							break;
						case inMenuBar: 
						{
					    	int32 mResult = MenuSelect(e.where);
      						int16 theMenu, theItem;
      						theMenu = HiWord(mResult); 
      						theItem = LoWord(mResult);
							doCommand(theMenu, theItem);
      						break;
      					}
					}
					break;
				case updateEvt:
					BeginUpdate(e.message);
 					EraseRect(&((GrafPtr) e.message)->portRect);
					switch (drawitem)
					{ 					
					case uprightCommand:
						drawType();
						break;
					case reflectCommand:
						drawType();
						break;
					case rotateCommand:
						drawType();
					break;
					case skewCommand:
						drawType();
					break;
					case linearCommand:
						drawType();
						break;
					default:
						break;
					} 
					EndUpdate(e.message);
					break;
				case keyDown:
	      		case autoKey:
					DoKeyDown(&e);
					break;
	      		default: break;
	
				}	/* switch */
			}	/* if */
		return 1;
	}	/* handleEvent */



void SetupMenus(void) 
	{
	  int16 i;
	  MyMenus = (MenuHandle *) NewPtr((sizeof(MenuHandle)) * menuCount);
	  for (i = 0; i < menuCount; i++) MyMenus[i] = GetMenu(firstMenuID + i);
	  /* The apple menu is special */
	  AddResMenu(MyMenus[appleMenu], (ResType) 'DRVR');
	  AddResMenu(MyMenus[fontMenu], (ResType) 'FONT');
	
	  /* Now insert all of the application menus in the menu bar and draw it */
	  for (i = 0; i < menuCount; i++)
	    if (MyMenus[i] != NULL) InsertMenu(MyMenus[i], 0);
	  CheckItem(MyMenus[drawMenu], drawitem,true);	
	  DrawMenuBar();
	}

int16 InitFontMenu()
{
	Rect b;
	int16 i,tempnum,userfontnum;
	fontitem = 0;
/* 
	loop over all the items in the Font Menu and see which faces are
	available, first dim those faces which aren't available to ATM,
*/
	numfonts = CountMItems(MyMenus[fontMenu]);
	for (i=1 ; i <= numfonts ; i++)
		{ 
			GetItem(MyMenus[fontMenu],i,fontname);
			GetFNum(fontname,&tempnum);
			if(fontAvailableATM(tempnum, 0))
			{
				fontitem = i;
				userfontnum = tempnum;
			}
			else
			{
				DisableItem(MyMenus[fontMenu],i);
			};
		}	/* for */

/* be lazy and use the last one found (if there is one) */
		if(fontitem)
		{
			CheckItem(MyMenus[fontMenu],fontitem ,true);
	  		DrawMenuBar();
			SetRect(&b, 100, 100, 500, 330);
			myWindow= (WindowPtr) NewWindow(0L, &b, fontname, 1, documentProc + 8, -1L, 1, 0L);
			SetPort(myWindow);
			TextFont(userfontnum);
		}
	return fontitem;
 } /* InitFontMenu  */

static void DoKeyDown(myEvent) 
	EventRecord *myEvent; 
{

	unsigned char charCode = (unsigned char) (myEvent->message & charCodeMask);
	
	if (myEvent->modifiers & cmdKey) 
  	{ /* command key */
		int32 mResult = MenuKey(charCode);
		int16 theMenu = HiWord(mResult); /* This is the resource ID */
		int16 theItem = LoWord(mResult);
		doCommand(theMenu, theItem);
	}
	return ;
}	/* KeyDown */


/*
   Display the About dialog.
*/
static void showAboutMeDialog() 
{
  GrafPtr savePort;
  int16 itemHit;
  DialogPtr theDialog;

  GetPort(&savePort);
  theDialog = GetNewDialog(aboutMeDLOG, NULL, (WindowPtr) -1);
  SetPort(theDialog);

  do { ModalDialog(NULL, &itemHit); } while (itemHit != okButton);

  CloseDialog(theDialog);

  SetPort(savePort);
  return;
}	/* showAboutMeDialog */


/*
 * Process mouse clicks in menu bar
 */
static void doCommand(theMenu, theItem)
  int16 theMenu, theItem; 
  {
	  int16 userfontnum;
	  switch (theMenu) 
	  {
	    case appleMenuID:
	      if (theItem == aboutMeCommand) 
	      {
	        	showAboutMeDialog();
	      }
	      else 
	      {
	        GrafPtr savePort;
	        char daName[256];
	        GetItem(MyMenus[appleMenu], theItem, daName);
	        GetPort(&savePort);
	        (void) OpenDeskAcc(daName);
	        SetPort(savePort);
	      }
	      break;
	
	    case fileMenuID:
	      switch (theItem) 
	      {
	        case quitCommand:
				ExitToShell();
				break;
	        default:
	        	break;
	      }
	      break;
	
	    case editMenuID:
	      /*
	       * Run this through SystemEdit first.
	       * SystemEdit will return FALSE if it's not a system window.
	       */
	      if (SystemEdit(theItem-1)) break;
	
	   
	   case fontMenuID:
	 		CheckItem(MyMenus[fontMenu], fontitem,false);	/* uncheck old item */
			CheckItem(MyMenus[fontMenu], theItem,true);		/* check new item */
	  		DrawMenuBar();
			GetItem(MyMenus[fontMenu],theItem,fontname);
			GetFNum(fontname,&userfontnum);
			TextFont(userfontnum);
			fontitem = theItem;
	    	SetWTitle(myWindow,fontname);
			InvalRect(&myWindow->portRect);
	    break;
        
 	    case drawMenuID:
	      switch (theItem) 
	      {
	        default:
				CheckItem(MyMenus[drawMenu], drawitem,false);	/* uncheck old item */
				CheckItem(MyMenus[drawMenu], theItem,true);		/* check new item */
	       		drawitem = theItem;
	      		InvalRect(&myWindow->portRect);
	       		break;
	      }
	      break;
	
	    default:
	      break;
	    } /*endswitch theMenu*/
	
	  HiliteMenu(0);
	  return;
  }

int16 drawType()
	{
	FixedMatrix m;
	char *c;
	int16 unrendered,loop;
	Fixed d[12];
	
	switch(drawitem)
	{
	 /* Example 1 */

	 case uprightCommand:
	 	{
			m.a = (Fixed) ( 226.7* 65536.0 + 0.5);
			m.b = (Fixed) 0.;
			m.c = (Fixed) 0.;
			m.d = (Fixed) (-226.7 * 65536.0 + 0.5);		
			m.tx = (Fixed) (100.3 * 65536.0 + 0.5);
			m.ty = (Fixed) (200.4 * 65536.0 + 0.5);
		
			MoveTo(0, 0);
			c = "A";
			unrendered = showTextATM(c, 1, &m);
			break;
		}
	 /* Example 2 */
	 case reflectCommand:
	 	{
			m.a = (Fixed) ( -79.7* 65536.0 + 0.5);
			m.b = (Fixed) 0.;
			m.c = (Fixed) 0.;
			m.d = (Fixed) (-204.6 * 65536.0 + 0.5);		
			m.tx = (Fixed) (400.3 * 65536.0 + 0.5);
			m.ty = (Fixed) (200.4 * 65536.0 + 0.5);

			MoveTo(0, 0);
			c = "Reversed";
			unrendered = showTextATM(c, 8, &m);
			break;
		}
	 /* Example 3 */
	 case rotateCommand:
	 	{
			m.a=(Fixed)(44.6*cos(25*DEGTORAD)*65536. + 0.5);
			m.b=(Fixed)(-44.6*sin(25*DEGTORAD)*65536. + 0.5);
			m.c=(Fixed)(-44.6*sin(25*DEGTORAD)*65536. + 0.5);
			m.d=(Fixed)(-44.6*cos(25*DEGTORAD)*65536. + 0.5);
 			m.tx = (Fixed) (60.3 * 65536.0 + 0.5);
			m.ty = (Fixed) (110.4 * 65536.0 + 0.5);

			MoveTo(0, 0);
			c = "Rotated";
			unrendered = showTextATM(c, 7, &m);
			break;
		}
	 /* Example 4 */
		case skewCommand:
	 	{
			m.a=(Fixed)(44.6 * 65536.0 + 0.5);
			m.b=(Fixed)(-44.6*tan(15*DEGTORAD)*65536.0 + 0.5);
			m.c=(Fixed)(83.2*tan(35*DEGTORAD)*65536.0 + 0.5);
			m.d=(Fixed)(-83.2*65536.0 + 0.5);
 			m.tx = (Fixed) (50.3 * 65536.0 + 0.5);
			m.ty = (Fixed) (120.4 * 65536.0 + 0.5);

			MoveTo(0, 0);
			c = "Skewed";
			unrendered = showTextATM(c, 6, &m);
			break;
		}
	 /* Example 5 */
	 case linearCommand:
	 	{
			m.a = (Fixed) ( 25* 65536.0 + 0.5);
			m.b = (Fixed) 0.;
			m.c = (Fixed) 0.;
			m.d = (Fixed) (-25 * 65536.0 + 0.5);
			m.tx = (Fixed) (10. * 65536.0 + 0.5);
			m.ty = (Fixed) (180. * 65536.0 + 0.5);
			/*   x and y widths are both 1 for 
			a 1 point font imaged with slope 1
			*/
			for (loop = 0; loop<12; loop++)
			d[loop] = (Fixed) (1 * 65536.0 + 0.5);
			MoveTo(0, 0);
			c = "Linear";
			unrendered = xyshowTextATM(c, 6, &m,d);
			break;
		}
	 default:
			break;
	
	}	/* end switch */
		
			return 1;
	}


Boolean  TrapAvailable(tNumber, tType)
    int16    tNumber;
    int16 tType;
{
    
    
    /* Check and see if the trap exists. */
    /* On 64K ROM machines, tType will be ignored. */
    
       return( NGetTrapAddress(tNumber, tType) !=
               GetTrapAddress(_Unimplemented) );
    
}
    
Boolean TrapImplemented(trapnumber)
    
    int16 trapnumber;
{
    
    /* define trap number for old MPW or non-MPW C */
    
       SysEnvRec theWorld; /* used to check if machine has new traps */
    
    /* Since WaitNextEvent and HFSDispatch both have the same trap
       number ($60), we can only call TrapAvailable for WaitNextEvent
       if we are on a machine that supports separate OS and Toolbox
       trap tables. We call SysEnvirons and check if machineType < 0. */
     
       SysEnvirons(1, &theWorld);
    
    /* Even if we got an error from SysEnvirons, the SysEnvirons glue
       has set up machineType. */
    
       if (theWorld.machineType < 0) {
          return(false);
          /* this ROM doesn't have separate trap tables  */
       } else {
          return(TrapAvailable(trapnumber, ToolTrap));
           /* check for trapnumber */
       }
    
}	/* TrapImplemented */
    
