/*
 * ATMTypes.h
 */

#ifndef _ATMTypes
#define _ATMTypes

#define fixed long
#define fixed12 int

#define _inttofixed(i) ((long) ((int) (i)) << 16)
#define _fixedone 0x00010000L

#define _fixedtointceiling(l) ((int) (((l) + (fixed) 0x0000ffffL) >> 16))
/* #define _fixedtointround(l) ((int) (((l) + (fixed) 0x00008000L) >> 16)) */
#define _fixedtointfloor(l) ((int) ((l) >> 16))

#define _fixed12tofixed(i) ((long) ((int) (i)) << 4)
#define _unsignedfixed12tofixed(i) ((long) ((unsigned int) (i)) << 4)

typedef struct
	{
	int xl;
	int yl;
	int xg;
	int yg;
	} intBoxATM;

typedef struct
	{
	fixed xl;
	fixed yl;
	fixed xg;
	fixed yg;
	} fixedBoxATM;

typedef struct
	{
	fixed a;
	fixed b;
	fixed c;
	fixed d;
	fixed tx;
	fixed ty;
	} fixedMatrixATM;

typedef struct
	{
	unsigned char *base;
	intBoxATM bounds;
	int depth;
	int breadth;
	} frameATM;

typedef struct
	{
	fixed **widths;
	fixed xs;
	fixed ys;
	fixed xe;
	fixed ye;
	fixed *displacements;
	} widthATM;

intBoxATM *setIntBox(intBoxATM *, int, int, int, int);
intBoxATM *intersectIntBox(intBoxATM *, intBoxATM *);
intBoxATM *unionIntBox(intBoxATM *, intBoxATM *);

fixedBoxATM *setFixedBox(fixedBoxATM *, fixed, fixed, fixed, fixed);
fixedBoxATM *intersectFixedBox(fixedBoxATM *, fixedBoxATM *);
fixedBoxATM *unionFixedBox(fixedBoxATM *, fixedBoxATM *);

#endif
