/* bBox.h version 2.0 */

#ifndef _ATMStrike
#define _ATMStrike

#include "ATMTypes.h"
#include <FontMgr.h>

int boxFondATMStrike(FamRec **, fixedBoxATM *, fixed *);
int expandATMStrike(FontRec **, intBoxATM *, int, int, int);

#endif

#include "ATMTypes.c"  		/* b box stuff 		  */
#include <color.h>
#include <math.h>
#include <stdlib.h>   	/* atoi   */
#include <stdio.h>		/* sscanf */
#include <quickDraw.h>

#define bBoxMenu		4  /* explicit MyMenus[] array index */
#define	pointSizeDLOG	1000
#define bBoxResultDLOG	137

/* Dialog field ids */
#define sizeField		4
#define boldStyle		5
#define italicStyle		6
#define outlineStyle	7
#define shadowStyle		8


#define	boldurxDelta	0.027		/* deltas for variations of styles - from Tech Tips doc */
#define	boldllyDelta	0.013
#define	shadowurxDelta	0.078125	/* 20/256	*/
#define shadowllyDelta	0.046875	/* 12/256	*/
#define italicMultiplier 0.175

float	DoPointSizeDialog(void);
void	DoBBoxResultDialog(int16,float);
void	UpdateStyles(DialogPtr theDialog,int16 action,int16 setThisOff);

typedef struct
	{
	int size;
	int style;
	int id;
	} FontAssocEntry;

typedef struct
	{
	int length;
	FontAssocEntry entry[1];
	} FontAssocTable;

typedef struct
	{
	int length;
	long offset[1];
	} FontOffsetTable;

typedef struct
	{
	int style;
	fixed12 xl;
	fixed12 yl;
	fixed12 xg;
	fixed12 yg;
	} FontBoxEntry;

typedef struct
	{
	int length;
	FontBoxEntry entry[1];
	} FontBoxTable;

typedef struct
	{
	int class;
	long offset;
	long reserved;
	unsigned char suffix[48];
	} FontStyleTable;

typedef struct
	{
	int style;
	int widths[1];
	} FontWidthEntry;

typedef struct
	{
	int length;
	FontWidthEntry entry[1];
	} FontWidthTable;

struct styleDeltas
{
  float llx; 
  float lly; 
  float urx;
  float ury;
  int	italicFlag;
  int	outlineFlag;
};

/******* GLOBALS ***********/

static struct styleDeltas styleData;

static int16	bBoxitem = 1; 
static char 	bBoxName[256];
static int16	sizeitem = 1;
static char 	sizeName[256];
